
/*

	Open Kray Tonemap Blending Plugin
	Matt Gorner
	05.11.2009
	
	v1.1
	
	Script to open the Kray Tonemap Blending plugin from the main UI without having to open the Master Plugins window

*/


@version 2.3
@script generic
@name Kray Open Tonemap Blending
 
generic
{

	/* Set the break variable */
    appActive = false;

	/* Store a list of Master Plugins attached to the scene */
    applied_master_scripts = Scene().server("MasterHandler");

	/* If a list exists ... */
    if(applied_master_scripts)
    {
    	/* Get the size of the array */
        counter = size(applied_master_scripts);

		/* Loop through until we find the 'KrayTonemapBlending' plugin */
        for(x = 1; x <= counter; x++){
            if(applied_master_scripts[x] == "KrayTonemapBlending"){
                appActive = true;
                break;
            }
        }
    }

	/* If it wasn't found, add the 'KrayTonemapBlending' plugin */
	if(!appActive){
        ApplyServer("MasterHandler","KrayTonemapBlending");
	}

	/* Reset break variable */
    appActive = false;

	/* Refresh the list of Master Plugins attached to the scene, otherwise the one we just added won't be there */
    applied_master_scripts = Scene().server("MasterHandler");

	/* If a list exists ... */
    if(applied_master_scripts){

    	/* Get the size of the array */
        counter = size(applied_master_scripts);

		/* Loop through until we find the 'KrayTonemapBlending' plugin */
        for(x = 1; x <= counter; x++){
            if(applied_master_scripts[x] == "KrayTonemapBlending"){
                appActive = true;
                break;
            }
        }
    }

	/* If it WAS found, EDIT the 'KrayTonemapBlending' plugin instead */
	if (appActive){

		/* Bring up the plugin interface */
		EditServer("MasterHandler",x);

	}else{

		/* Something went wrong, tell the user */
		error("Kray Message: An error occured trying to edit the Kray Tonemap Blending Plugin");
	}
}
